/**********************************
 *
 * Copyright (C) 2004 Paul Pierce
 *
 * Permission instanceof hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software instanceof furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 *********************************/


package com.piercefuller.a7trk.a7tview;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/// <summary>
/// Summary description for ColorDialog.
/// </summary>
public class ColorDialog extends JDialog
{
	private ColorDialog myself;
	private A7tView parent;
	private Colors colors;

	private JButton button1;
	private JButton button2;
	private JButton button3;
	private JButton button4;
	private JButton button5;
	private JButton button6;
	private JButton button7;
	private JButton button8;
	private JButton button9;
	private JButton buttona;

	public ColorDialog(A7tView parent, Colors colors)
	{
		myself = this;
		this.parent = parent;
		this.colors = colors;

		button1 = new JButton();
		button2 = new JButton();
		button3 = new JButton();
		button4 = new JButton();
		button5 = new JButton();
		button6 = new JButton();
		button7 = new JButton();
		button8 = new JButton();
		button9 = new JButton();
		buttona = new JButton();

		// 
		// button1
		// 
		//button1.setLocation(new Point(24, 24));
		//button1.setName("button1");
		//button1.setSize(new Dimension(72, 23));
		//button1.setNextFocusableComponent(button2);
		button1.setText("Raw");
		button1.addActionListener(button1_Click);
		// 
		// button2
		// 
		//button2.setLocation(new Point(24, 56));
		//button2.setName("button2");
		//button2.setNextFocusableComponent(button3);
		button2.setText("Lump");
		button2.addActionListener(button2_Click);
		// 
		// button3
		// 
		//button3.setLocation(new Point(24, 120));
		//button3.setName("button3");
		//button3.setNextFocusableComponent(button4);
		button3.setText("Dir");
		button3.addActionListener(button3_Click);
		// 
		// button4
		// 
		//button4.setLocation(new Point(72, 152));
		//button4.setName("button4");
		//button4.setNextFocusableComponent(button5);
		button4.setText("Slider");
		button4.addActionListener(button4_Click);
		// 
		// button5
		// 
		//button5.setLocation(new Point(128, 24));
		//button5.setName("button5");
		//button5.setNextFocusableComponent(button6);
		button5.setText("Center Line");
		button5.addActionListener(button5_Click);
		// 
		// button6
		// 
		//button6.setLocation(new Point(128, 56));
		//button6.setName("button6");
		//button6.setNextFocusableComponent(button7);
		button6.setText("Zero Line");
		button6.addActionListener(button6_Click);
		// 
		// button7
		// 
		//button7.setLocation(new Point(128, 88));
		//button7.setName("button7");
		//button7.setNextFocusableComponent(button8);
		button7.setText("Clip Line");
		button7.addActionListener(button7_Click);
		// 
		// button8
		// 
		button8.setBackground(Color.white);
		//button8.setLocation(new Point(24, 184));
		//button8.setName("button8");
		//button8.setSize(new Dimension(176, 23));
		//button8.setNextFocusableComponent(button9);
		button8.setText("Background");
		button8.addActionListener(button8_Click);
		// 
		// button9
		// 
		//button9.setLocation(new Point(24, 88));
		//button9.setName("button9");
		button9.setText("Base");
		button9.addActionListener(button9_Click);
		// 
		// buttona
		// 
		//buttona.setLocation(new Point(24, 88));
		//buttona.setName("buttona");
		buttona.setText("Crowd");
		buttona.addActionListener(buttona_Click);
		// 
		// ColorDialog
		// 
		//setMinimumSize(new Dimension(216, 214));

		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		add(button1);
		add(button2);
		add(button3);
		add(button9);
		add(buttona);
		add(button5);
		add(button6);
		add(button7);
		add(button4);
		add(button8);

		button1.setBackground(colors.getBackgroundColor());
		button2.setBackground(colors.getBackgroundColor());
		button3.setBackground(colors.getBackgroundColor());
		button4.setBackground(colors.getBackgroundColor());
		button5.setBackground(colors.getBackgroundColor());
		button6.setBackground(colors.getBackgroundColor());
		button7.setBackground(colors.getBackgroundColor());
		button8.setBackground(colors.getBackgroundColor());
		button9.setBackground(colors.getBackgroundColor());
		buttona.setBackground(colors.getBackgroundColor());

		button1.setForeground(colors.getRawColor());
		button2.setForeground(colors.getLumpColor());
		button3.setForeground(colors.getDirectionColor());
		button4.setForeground(colors.getSliderColor());
		button5.setForeground(colors.getCenterColor());
		button6.setForeground(colors.getZeroColor());
		button7.setForeground(colors.getClipColor());
		button9.setForeground(colors.getBaseColor());
		buttona.setForeground(colors.getCrowdColor());

		int wide = 0;
		if (button1.getPreferredSize().width > wide) {
			wide = button1.getPreferredSize().width;
		}
		if (button2.getPreferredSize().width > wide) {
			wide = button2.getPreferredSize().width;
		}
		if (button3.getPreferredSize().width > wide) {
			wide = button3.getPreferredSize().width;
		}
		if (button4.getPreferredSize().width > wide) {
			wide = button4.getPreferredSize().width;
		}
		if (button5.getPreferredSize().width > wide) {
			wide = button5.getPreferredSize().width;
		}
		if (button6.getPreferredSize().width > wide) {
			wide = button6.getPreferredSize().width;
		}
		if (button7.getPreferredSize().width > wide) {
			wide = button7.getPreferredSize().width;
		}
		if (button8.getPreferredSize().width > wide) {
			wide = button8.getPreferredSize().width;
		}
		if (button9.getPreferredSize().width > wide) {
			wide = button9.getPreferredSize().width;
		}
		if (buttona.getPreferredSize().width > wide) {
			wide = buttona.getPreferredSize().width;
		}
		Dimension bdim = new Dimension(wide, button1.getPreferredSize().height);
		button1.setPreferredSize(bdim);
		button2.setPreferredSize(bdim);
		button3.setPreferredSize(bdim);
		button4.setPreferredSize(bdim);
		button5.setPreferredSize(bdim);
		button6.setPreferredSize(bdim);
		button7.setPreferredSize(bdim);
		button8.setPreferredSize(bdim);
		button9.setPreferredSize(bdim);
		buttona.setPreferredSize(bdim);

		setName("ColorDialog");
		setTitle("Choose Colors");
		setModalityType(Dialog.ModalityType.MODELESS);
		pack();
	}


	private Action button1_Click = new AbstractAction("button1_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getRawColor());
		colors.setRawColor(color);
		button1.setForeground(color);
		parent.needUpdate();
	}};

	private Action button2_Click = new AbstractAction("button2_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getLumpColor());
		colors.setLumpColor(color);
		button2.setForeground(color);
		parent.needUpdate();
	}};

	private Action button3_Click = new AbstractAction("button3_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getDirectionColor());
		colors.setDirectionColor(color);
		button3.setForeground(color);
		parent.needUpdate();
	}};

	private Action button4_Click = new AbstractAction("button4_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getSliderColor());
		colors.setSliderColor(color);
		button4.setForeground(color);
		parent.needUpdate();
	}};

	private Action button5_Click = new AbstractAction("button5_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getCenterColor());
		colors.setCenterColor(color);
		button5.setForeground(color);
		parent.needUpdate();
	}};

	private Action button6_Click = new AbstractAction("button6_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getZeroColor());
		colors.setZeroColor(color);
		button6.setForeground(color);
		parent.needUpdate();
	}};

	private Action button7_Click = new AbstractAction("button7_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getClipColor());
		colors.setClipColor(color);
		button7.setForeground(color);
		parent.needUpdate();
	}};

	private Action button8_Click = new AbstractAction("button8_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getBackgroundColor());
		colors.setBackgroundColor(color);
		button1.setBackground(colors.getBackgroundColor());
		button2.setBackground(colors.getBackgroundColor());
		button3.setBackground(colors.getBackgroundColor());
		button4.setBackground(colors.getBackgroundColor());
		button5.setBackground(colors.getBackgroundColor());
		button6.setBackground(colors.getBackgroundColor());
		button7.setBackground(colors.getBackgroundColor());
		button8.setBackground(colors.getBackgroundColor());
		button9.setBackground(colors.getBackgroundColor());
		parent.needUpdate();
	}};

	private Action button9_Click = new AbstractAction("button9_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getBaseColor());
		colors.setBaseColor(color);
		button9.setForeground(color);
		parent.needUpdate();
	}};

	private Action buttona_Click = new AbstractAction("buttona_Click") { public void actionPerformed(ActionEvent e)
	{
		Color color = JColorChooser.showDialog(myself, ((JButton)e.getSource()).getText(), colors.getCrowdColor());
		colors.setCrowdColor(color);
		buttona.setForeground(color);
		parent.needUpdate();
	}};

}
