/**
 * NullLog.java
 *
 * Copyright (C) 2007 Paul R. Pierce
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see http://www.gnu.org/licenses/gpl.txt
 */
package org.avparade.xml;

import java.util.Calendar;
import org.w3c.dom.*;

/**
 * org.avparade.xml.NullLog
 *
 */
public class NullLog implements Log {

	/* (non-Javadoc)
	 * @see org.avparade.xml.Log#add(java.lang.String)
	 */
	public void add(String entry) {
	}

	/* (non-Javadoc)
	 * @see org.avparade.xml.Log#add(org.w3c.dom.Element)
	 */
	public void add(Element entry) {
	}

	/* (non-Javadoc)
	 * @see org.avparade.xml.Log#getDocument()
	 */
	public Document getDocument() {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.avparade.xml.Log#flush()
	 */
	public void flush() throws Exception {
	}

	/* (non-Javadoc)
	 * @see org.avparade.xml.Log#mostRecent(java.lang.String, java.lang.String)
	 */
	public Element mostRecent(String entryName, String id) {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.avparade.xml.Log#whatTime(org.w3c.dom.Element)
	 */
	public Calendar whatTime(Element entry) {
		return null;
	}

}
