/**
 * XMLHandler.java
 *
 * Copyright (C) 2006 Paul R. Pierce
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see http://www.gnu.org/licenses/gpl.txt
 */
package org.avparade.xml;

import org.w3c.dom.*;

/**
 * org.avparade.xml.XMLHandler
 *
 */
public interface XMLHandler {
	Document createDocument(String namespace, String documentElementName);
	// Source can be File, InputStream or String
	Document parse(Object source, Document config);
	String toString(Document doc, Document config);
	// Dest can be OutputStream, Writer or File
	void write(Object dest, Document doc, Document config);
	
	// Utilities
	String elementContent(Element element);
	Element firstElementChild(Node node, String namespace, String tag);
	Element nextElementChild(Node node, String namespace, String tag);
	
	public class Factory {
		public static XMLHandler getInstance() {
			try {
				return new JaxpXMLHandler();
			} catch (Exception e) {
				return null;
			}
		}
	}
}
